namespace AddisonWesley.Michaelis.EssentialCSharp.Chapter14.Listing14_08
{
    using System;
    using Listing14_01;
    using Listing14_05;

    public class Program
    {
        public static void Main()
        {
            Thermostat thermostat = new Thermostat();
            Heater heater = new Heater(60);
            Cooler cooler = new Cooler(80);

            Action<float> delegate1;
            Action<float> delegate2;
            Action<float> delegate3;

            // Uwaga: w wersji C# 1.0 należy zastosować składnię 
            // new Action (cooler.OnTemperatureChanged).
            delegate1 = heater.OnTemperatureChanged;
            delegate2 = cooler.OnTemperatureChanged;

            Console.WriteLine("Łączenie delegatów za pomocą operatora +:");
            delegate3 = delegate1 + delegate2;
            delegate3(60);

            Console.WriteLine("Rozdzielanie delegatów za pomocą operatora -:");
            delegate3 = delegate3 - delegate2;
            delegate3(60);
        }
    }
}